unit Enigma;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls, ExtCtrls;

type
  TEM = class(TForm)
    Walzenlage: TLabeledEdit;
    Eingabe: TLabeledEdit;
    Start: TSpeedButton;
    Ausgabe: TLabeledEdit;
    Ringe: TLabeledEdit;
    Stecker: TLabeledEdit;
    Grund: TLabeledEdit;
    Button1: TButton;
    Button2: TButton;
    Button7: TButton;
    Button6: TButton;
    Button8: TButton;
    Button10: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button9: TButton;
    Button11: TButton;
    Button12: TButton;
    Button17: TButton;
    Button16: TButton;
    Button18: TButton;
    Button20: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button19: TButton;
    Button21: TButton;
    Button22: TButton;
    Button26: TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Ende: TBitBtn;
    ReflektorWahl: TRadioGroup;
    RotorAnzeige: TMemo;
    procedure WalzenlageKeyPress(Sender: TObject; var Key: Char);
    procedure StartClick(Sender: TObject);
    procedure RingeKeyPress(Sender: TObject; var Key: Char);
    procedure ButtonClick(Sender: TObject);
    procedure ButtonEinAus(Zustand:Boolean);
    procedure EndeClick(Sender: TObject);
    procedure Codieren(Zeichen:Char);
    procedure SteckerKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Anzeige;
  private
    { Private-Deklarationen }
   x,nut_L,w_L,r_L,s_L,nut_M,w_M,r_M,s_M,nut_R,w_R,r_R,s_R,LS:Integer;
   R_L_Liste,R_Linvers,R_M_Liste,R_Minvers,R_R_Liste,R_Rinvers,
   S,U:Array[0..25]of Integer;
  public
    { Public-Deklarationen }
  end;

var
  EM: TEM;

implementation

{$R *.dfm}
{$R+,Q+}
 const Rotor:Array[1..5]of String=('EKMFLGDQVZNTOWYHXUSPAIBRCJ',  // Rotor I
                                   'AJDKSIRUXBLHWTMCQGZNPYFVOE',  // Rotor II
                                   'BDFHJLCPRTXVZNYEIWGAKMUSQO',  // Rotor III
                                   'ESOVPZJAYQUIRHXLNFTGKDCMWB',  // Rotor IV
                                   'VZBRGITYUPSDNHLXAWMJQOFECK'); // Rotor V
        Nut='QEVJZ';
        ReflectorB='YRUHQSLDPXNGOKMIEBFZCWVJAT';                  // Reflector B
        ReflectorC='FVPJIAOYEDRZXWGCTKUQSBNMHL';                  // Reflector C
        Alfa='ABCDEFGHIJKLMNOPQRSTUVWXYZ';
        Ziffern='12345';

 procedure TEM.WalzenlageKeyPress(Sender: TObject; var Key: Char);
  var Ziffern:Set of Char;
      K:Integer;
  begin
   Ziffern:=['1'..'5'];
   for K:=1 to Length(Walzenlage.Text) do
    Ziffern:=Ziffern-[Walzenlage.Text[K]];
   if not(Key in Ziffern+[#8]) then Key:=#0;
  end;

 procedure TEM.SteckerKeyPress(Sender: TObject; var Key: Char);
  var Buchstaben:Set of Char;
      K:Integer;
  begin
   Key:=Upcase(Key);
   Buchstaben:=['A'..'Z'];
   for K:=1 to Length(Stecker.Text) do
    Buchstaben:=Buchstaben-[Stecker.Text[K]];
   if not(Key in Buchstaben+[#8]) then Key:=#0;
  end;

 procedure TEM.RingeKeyPress(Sender: TObject; var Key: Char);
  begin
   if not(Key in['A'..'Z','a'..'z',#8]) then Key:=#0;
  end;

 procedure TEM.ButtonEinAus(Zustand:Boolean);
  var K:Integer;
      Button:TButton;
  begin
   for K:=1 to Length(Alfa) do
    begin
     Button:=TButton(FindComponent('Button'+IntToStr(K)));
     Button.Enabled:=Zustand;
    end;
  end;

 procedure TEM.StartClick(Sender: TObject);
  var i:Integer;
      Reflektor:String;
 { Enigma-Simulator
   Version vom 4.10.2005
   Simulation einer Wehrmachts-Enigma um 1938.
   5 mgliche Walzen I=1, II=2, III=3, IV=4, V=5, feste Umkehrwalze `B'
   Schlssel:
   1. Walzenlage (w_L,w_M,w_R)
   2. Ringstellung (r_L,r_M,r_R)
   3. Steckerverbindung S
   4. Grundstellung (s_L,s_M,s_R)
}
  begin
   if Length(Walzenlage.Text)<3 then
    begin
     MessageDlg('Die Walzenlage ist NICHT korrekt!',mtError,[mbOk],0);
     exit;
    end;
   if Length(Ringe.Text)<3 then
    begin
     MessageDlg('Die Ringstellung ist NICHT korrekt!',mtError,[mbOk],0);
     exit;
    end;
   // Umkehrwalze
   if ReflektorWahl.ItemIndex=0 then Reflektor:=ReflectorB
   else Reflektor:=ReflectorC;
   for i:=0 to 25 do
    U[i]:=pos(Reflektor[i+1],Alfa)-1;
   // Walzenlage
   w_L:=pos(Walzenlage.Text[1],Ziffern);
   w_M:=pos(Walzenlage.Text[2],Ziffern);
   w_R:=pos(Walzenlage.Text[3],Ziffern);
   for i:=0 to 25 do
    begin
     R_L_Liste[i]:=pos(Rotor[w_L][i+1],Alfa)-1;
     R_M_Liste[i]:=pos(Rotor[w_M][i+1],Alfa)-1;
     R_R_Liste[i]:=pos(Rotor[w_R][i+1],Alfa)-1;
     R_Linvers[R_L_Liste[i]]:=i;
     R_Minvers[R_M_Liste[i]]:=i;
     R_Rinvers[R_R_Liste[i]]:=i;
    end;
   nut_L:=pos(Nut[w_L],Alfa)-1;
   nut_M:=pos(Nut[w_M],Alfa)-1;
   nut_R:=pos(Nut[w_R],Alfa)-1;
   // Ringstellung
   r_L:=pos(Ringe.Text[1],Alfa)-1;
   r_M:=pos(Ringe.Text[2],Alfa)-1;
   r_R:=pos(Ringe.Text[3],Alfa)-1;
   // Steckerverbindung
   for i:=0 to 25 do S[i]:=i; // keine Steckverbindungen
   LS:=Length(Stecker.Text);
   if odd(LS) then // ungerade Anzahl
    begin
     MessageDlg('Die Stecker sind NICHT korrekt!',mtError,[mbOk],0);
     exit;
    end;
   for i:=1 to LS div 2 do
    begin
     S[pos(Stecker.Text[2*i-1],Alfa)-1]:=pos(Stecker.Text[2*i],Alfa)-1;
     S[pos(Stecker.Text[2*i],Alfa)-1]:=pos(Stecker.Text[2*i-1],Alfa)-1;
    end;
   // Grundstellung
   s_L:=pos(Grund.Text[1],Alfa)-1;
   s_M:=pos(Grund.Text[2],Alfa)-1;
   s_R:=pos(Grund.Text[3],Alfa)-1;
   ButtonEinAus(True);
   Eingabe.Text:='';
   Ausgabe.Text:='';
   Walzenlage.ReadOnly:=True;
   Ringe.ReadOnly:=True;
   Grund.ReadOnly:=True;
   Stecker.ReadOnly:=True;
   KeyPreview:=True; // Tastaturereignisse werden zuerst ans Formular geschickt
   Start.Enabled:=False;
   Ende.Enabled:=True;
   RotorAnzeige.Clear;
   Anzeige;
  end;

 procedure TEM.Anzeige;
  var K:Integer;
      Zeile:String;
  begin
   Zeile:='';RotorAnzeige.Clear;
   for K:=1 to 26 do Zeile:=Zeile+Format('%3s',[Alfa[K]]);
   RotorAnzeige.Lines.Add(Zeile);
   Zeile:='';
   for K:=0 to 25 do Zeile:=Zeile+Format('%3d',[K]);
   RotorAnzeige.Lines.Add(Zeile);
   RotorAnzeige.Lines.Add('');
   Zeile:='';
   for K:=0 to 25 do Zeile:=Zeile+Format('%3d',[R_R_Liste[K]]);
   //for K:=0 to s_R-1 do Zeile:=Zeile+Format('%3d',[R_R_Liste[K]]);
   RotorAnzeige.Lines.Add(Zeile+'  Rotor '+IntToStr(w_R));
   Zeile:='';
   for K:=0 to 25 do Zeile:=Zeile+Format('%3d',[R_M_Liste[K]]);
   RotorAnzeige.Lines.Add(Zeile+'  Rotor '+IntToStr(w_M));
   Zeile:='';
   for K:=0 to 25 do Zeile:=Zeile+Format('%3d',[R_L_Liste[K]]);
   RotorAnzeige.Lines.Add(Zeile+'  Rotor '+IntToStr(w_L));
   Zeile:='';
   for K:=0 to 25 do Zeile:=Zeile+Format('%3d',[U[K]]);
   RotorAnzeige.Lines.Add(Zeile+'  Reflektor');
  end;

 procedure TEM.ButtonClick(Sender: TObject);
  var Button:TButton;
      K:Integer;
      Zeichen:Char;
  begin
   // Button finden
   for K:=1 to Length(Alfa) do
    begin
     Button:=TButton(FindComponent('Button'+IntToStr(K)));
     if Button=Sender then
      begin Zeichen:=Alfa[K];Break end
    end;
   Eingabe.Text:=Eingabe.Text+Zeichen;
   Codieren(Zeichen);
  end;

 procedure TEM.Codieren(Zeichen:Char);
  var Zeile:String;
  begin
    // zunchst werden die Rotoren weitergedreht
   if s_M=nut_M then begin inc(s_L);inc(s_M);inc(s_R) end
   else if s_R=nut_R then begin inc(s_M);inc(s_R) end
        else inc(s_R);
   s_L:=s_L mod 26;
   s_M:=s_M mod 26;
   s_R:=s_R mod 26;
   Grund.Text:=Alfa[s_L+1]+Alfa[s_M+1]+Alfa[s_R+1];
   Anzeige;
   Zeile:='';
   // Verschlsselung
   x:=pos(Zeichen,Alfa)-1;
   Zeile:=Zeile+Format('%3d',[x])+' -->';
   x:=S[x]; // Steckerverbindung
   Zeile:=Zeile+Format('%3d',[x]);
   x:=(R_R_Liste[(x+26-r_R+s_R)mod 26]+(26+r_R-s_R))mod 26; // Rotor R_R
   Zeile:=Zeile+Format('%3d',[x]);
   x:=(R_M_Liste[(x+26-r_M+s_M)mod 26]+(26+r_M-s_M))mod 26; // Rotor R_M
   Zeile:=Zeile+Format('%3d',[x]);
   x:=(R_L_Liste[(x+26-r_L+s_L)mod 26]+(26+r_L-s_L))mod 26; // Rotor R_L
   Zeile:=Zeile+Format('%3d',[x]);
   x:=U[x]; // Umkehrwalze
   Zeile:=Zeile+Format('%3d',[x]);
   x:=(R_Linvers[(x+26-r_L+s_L)mod 26]+(26+r_L-s_L))mod 26; // Rotor R_L invers
   Zeile:=Zeile+Format('%3d',[x]);
   x:=(R_Minvers[(x+26-r_M+s_M)mod 26]+(26+r_M-s_M))mod 26; // Rotor R_M invers
   Zeile:=Zeile+Format('%3d',[x]);
   x:=(R_Rinvers[(x+26-r_R+s_R)mod 26]+(26+r_R-s_R))mod 26; // Rotor R_R invers
   Zeile:=Zeile+Format('%3d',[x]);
   x:=S[x]; // Steckerverbindung
   Zeile:=Zeile+' -->'+Format('%3d',[x]);  
   RotorAnzeige.Lines.Add(Zeile);
   Ausgabe.Text:=Ausgabe.Text+Alfa[x+1];
  end;

 procedure TEM.EndeClick(Sender: TObject);
  begin
   ButtonEinAus(False);
   Walzenlage.ReadOnly:=False;
   Ringe.ReadOnly:=False;
   Grund.ReadOnly:=False;
   Stecker.ReadOnly:=False;
   KeyPreview:=False;
   Start.Enabled:=True;       
   Ende.Enabled:=False;
  end;

 procedure TEM.FormKeyPress(Sender: TObject; var Key: Char);
  begin
   if pos(Upcase(Key),Alfa)>0 then
    begin
     Eingabe.Text:=Eingabe.Text+Upcase(Key);
     Codieren(Upcase(Key));
    end 
  end;

end.

